##########################################################################
#䗦̐i12zj
#
#x: 
#n: xkCs
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#theta: 䗦, xaste: \z, Odds:IbY
#log_lik;ΐޓx
##########################################################################
Bi01 <- function(x,n,prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
                 see=1234, cha=5, war=1000, ite=21000, fi=NA)
{
   library(rstan)
   dat <- list(x=x,n=n)
   scr <- "stan/Bi01.stan"                                # Stan t@C
   par<-c("theta","xaste","Odds","log_lik")               # samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,
             seed=see,chains=cha,warmup=war,iter=ite, fit=fi)
   ext<-extract(fit,par);
   out<-list(fit=fit,par=par,prob=prob,
        theta=ext$theta,xaste=ext$xaste, Odds=ext$Odds,log_lik=ext$log_lik);
   class(out)<-'Bi01'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Bi01'̃IuWFNg
#degits=3 : ̊ۂ
#pr1=F : theta̍ŏl
#cr1=F : x*̍ŏl
#cr2=F : IbY̍ŏl
##########################################################################
print.Bi01<-function(x,degits=3,pr1=F,cr1=F,cr2=F)
{
   log_lik<-x$log_lik;theta<-x$theta;xaste<-x$xaste;Odds<-x$Odds;
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   U<-matrix(0,length(theta),3)
   co<-0;lab<-NULL
   if(is.numeric(pr1)){co<- co+1;U[,co]<- ifelse(theta> pr1, 1, 0);
         lab<-c(lab,paste("䗦(",pr1,")傫",sep=""))}
   if(is.numeric(cr1)){co<- co+1;U[,co]<- ifelse(xaste> cr1, 1, 0);
         lab<-c(lab,paste("x*(",cr1,")傫",sep=""))}
   if(is.numeric(cr2)){co<- co+1;U[,co]<- ifelse(Odds>  cr2, 1, 0);
         lab<-c(lab,paste("IbY(",cr2,")傫",sep=""))}
   if(co>0.9){
      Uc<-matrix(colMeans(as.matrix(U[,1:co])),co,1);
      rownames(Uc)<-lab
      }else{Uc<-0.0}
   print(round(Uc,degits))
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic,Uc=Uc)
   return(invisible(out))
}  
