##########################################################################
#1Q̐KzɊւ鐄
#
#x:xNg`̃f[^ 
#prior=F : _lBTȂ玖Oz͈̔͂wBFȂw肹B
#mL, mH, sL, sH : Oz̃p^
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#mu:, sigma:W΍, xaste:\z, log_lik:ΐޓx
##########################################################################
G1mean <- function(x,prior=F, mL=-1000, mH=1000, sL=0, sH=100,
prob=c(0.025, 0.05, 0.5, 0.95, 0.975),see=1234,cha=5,war=1000,ite=21000,fi=NA)
{
   library(rstan)
   if (prior) {
     dat <- list(n=length(x),x=x,mL=mL,mH=mH,sL=sL,sH=sH)
     scr <- "stan/G1meanPT.stan"                           # Stan t@C
   } else {
     dat <- list(n=length(x),x=x)
     scr <- "stan/G1meanPF.stan"                           # Stan t@C
   }
   par<-c("mu","sigma","xaste","log_lik")        # samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,seed=see,chains=cha,warmup=war,iter=ite, fit=fi)
   ext<-extract(fit, c("mu","sigma","xaste","log_lik"))
   mu<-ext$mu; sigma<-ext$sigma; xaste<-ext$xaste; log_lik<-ext$log_lik
   out<-list(fit=fit,par=par,prob=prob,mu=mu,sigma=sigma,xaste=xaste,log_lik=log_lik)
   class(out)<-'G1mean'
   return(invisible(out))
}
##########################################################################
#̃\bh
#x:NX 'G1mean'̃IuWFNg
#degits=3 : ̊ۂ
#cr1=F : ʗʂ̊_      (lŎw)
#cr2a=F : z֐        (lŎw)
#cr2b=F : z֐        (lŎw)
#cr3=F : lƂ̔̊_(lŎw)
#cr4=F : ϒlcr4菬m(lŎw)
#cr5=F : cr1ɂʗʂcr5菬m(ʗʂŎw)
#pr1=F : _̊_        (̊mŎwj
#pr2=F : cr2̗̈悪ϑmApr2傫m(mŎw)
##########################################################################
print.G1mean<-function(x,degits=3,cr1=F,cr2a=F,cr2b=F,cr3=F,cr4=F,cr5=F,pr1=F,pr2=F)
{
   mu<-x$mu; sigma<-x$sigma; xaste<-x$xaste; log_lik<-x$log_lik
   prob<-x$prob
   G<-matrix(0,length(mu),6)
   G[,1]<- sigma^2;                  #U
   G[,2]<- sigma/mu;                 #ϓW
   co<-2; lab<-c("U","ϓW")
   if(is.numeric(cr1)){co<- co+1;G[,co]<- (mu-cr1)/sigma;
      lab<-c(lab,paste("ʗ(",cr1,")",sep=""))}
   if(is.numeric(pr1)){co<- co+1;G[,co]<- mu+qnorm(pr1)*sigma;
      lab<-c(lab,paste("_(",pr1,")",sep=""))}   
   if((is.numeric(cr2a))&(!is.numeric(cr2b)))
                      {co<- co+1;G[,co]<- pnorm(cr2a,mu,sigma);
      lab<-c(lab,paste("l(",cr2a,")菬m",sep=""))}
   if((is.numeric(cr2b))&(!is.numeric(cr2a)))
                      {co<- co+1;G[,co]<- 1-pnorm(cr2b,mu,sigma);
      lab<-c(lab,paste("l(",cr2b,")傫m",sep=""))}
   if((is.numeric(cr2a))&(is.numeric(cr2b)))
                      {co<- co+1;G[,co]<- pnorm(cr2a,mu,sigma)-pnorm(cr2b,mu,sigma);
      lab<-c(lab,paste("l(",cr2b,")傫(",cr2a,")菬m",sep=""))}
   if(is.numeric(cr3)){co<- co+1;G[,co]<- xaste/cr3;
      lab<-c(lab,paste("_Ƃ̔(",cr3,")",sep=""))}
   Gc<-cbind(
      apply(G[,1:co],2,mean),
      apply(G[,1:co],2,sd),
      t(apply(G[,1:co],2,quantile, probs=prob))
   )
   colnames(Gc)<-c("EAP","post.sd",prob)
   rownames(Gc)<-lab
   U<-matrix(0,length(mu),4)
   co<-0;lab<-NULL
   if(is.numeric(cr4)){co<- co+1;U[,co]<- ifelse(mu< cr4,    1, 0);
         lab<-c(lab,paste("ϒl(",cr4,")菬m",sep=""))}
   if((is.numeric(cr2a))&(!is.numeric(cr2b)))
                      {co<- co+1;U[,co]<- ifelse(xaste< cr2a,1,0);
      lab<-c(lab,paste("l(",cr2a,")菬m(_)",sep=""))}
   if((is.numeric(cr2b))&(!is.numeric(cr2a)))
                      {co<- co+1;U[,co]<- ifelse(xaste> cr2b,1,0);
      lab<-c(lab,paste("l(",cr2b,")傫m(_)",sep=""))}
   if((is.numeric(cr2a))&(is.numeric(cr2b)))
                      {co<- co+1;U[,co]<- ifelse((xaste< cr2a)&(xaste> cr2b),1,0);
      lab<-c(lab,paste("l(",cr2b,")傫(",cr2a,")菬m(_)",sep=""))}
   if(is.numeric(cr5)){co<- co+1;U[,co]<- ifelse(((mu-cr1)/sigma)< cr5, 1, 0);
         lab<-c(lab,paste("(",cr1,")ɂʗʂ(",cr5,")菬m",sep=""))}
   if((is.numeric(cr2a))&(!is.numeric(cr2b)))
                      {co<- co+1;U[,co]<- ifelse(pnorm(cr2a,mu,sigma)>pr2,1,0);
      lab<-c(lab,paste("l(",cr2a,")菬m(",pr2,")傫m",sep=""))}
   if((is.numeric(cr2b))&(!is.numeric(cr2a)))
                      {co<- co+1;U[,co]<- ifelse(1-pnorm(cr2b,mu,sigma)>pr2,1,0);
      lab<-c(lab,paste("l(",cr2b,")傫m(",pr2,")傫m",sep=""))}
   if((is.numeric(cr2a))&(is.numeric(cr2b)))
                      {co<- co+1;U[,co]<- ifelse(pnorm(cr2a,mu,sigma)-pnorm(cr2b,mu,sigma)>pr2,1,0);
      lab<-c(lab,paste("l(",cr2b,")傫(",cr2a,")菬m(",pr2,")傫m",sep=""))}
   if(co>0.9){
      Uc<-matrix(colMeans(as.matrix(U[,1:co])),co,1);
      rownames(Uc)<-lab
      }else{Uc<-0.0}
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(round(Gc,degits))
   print(round(Uc,degits))
   out<-list(G=G,Gc=Gc,Uc=Uc)
   return(invisible(out))
}
