##########################################################################
#Ή̂QQ̍𐄑
#
#x:ns2̍s`̃f[^ (ϒl̑傫ȌQ1ڂɎw)
#EQU=1 : _lB1Ȃ瓙UB0ȂقȂ镪UB
#prior=F : _lBTȂ玖Oz͈̔͂wBFȂw肹B
#mL=-1000, mH=1000, sL=0, sH=100 : Oz̃p^
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
# fit:stan̏o, par:ꐔXg, prob:mxNg, 
# mu1:1Q, mu2:2Q, sigma1:1QW΍, sigma2:2QW΍, 
# rho:֌W, xaste1:\z1, xaste2:\z2, log_lik:ΐޓx
##########################################################################
G2pair <- function(x,EQU=1,prior=F,mL=-1000, mH=1000, sL=0, sH=100,
            prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
            see=1234, cha=5, war=1000, ite=21000, fi=NA)
{
   library(rstan)
   if (prior) {
     dat <- list(n=nrow(x),x=x,EQU=EQU,mL=mL,mH=mH,sL=sL,sH=sH)
     scr <- "stan/G2pairPT.stan"                           # Stan t@C
   } else {
     dat <- list(n=nrow(x),x=x,EQU=EQU)
     scr <- "stan/G2pairPF.stan"                           # Stan t@C
   }
   par<-c("mu","sigma1","sigma2","rho","xaste","log_lik")# TvOϐ
   fit<-stan(file=scr,data=dat,pars=par,seed=see,chains=cha,warmup=war,iter=ite, fit=fi)
   ext<-extract(fit, par);    mu1<-ext$mu[,1]; mu2<-ext$mu[,2]; 
   sigma1<-ext$sigma1; sigma2<-ext$sigma2; rho<-ext$rho;
   xaste1<-ext$xaste[,1]; xaste2<-ext$xaste[,2]; log_lik<-ext$log_lik
   out<-list(EQU=EQU,prior=prior,fit=fit,par=par,prob=prob,mu1=mu1,mu2=mu2,
       sigma1=sigma1,sigma2=sigma2,rho=rho,
       xaste1=xaste1,xaste2=xaste2,log_lik=log_lik)
   class(out)<-'G2pair'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'G2pair'̃IuWFNg
#onlydiff=T _Ɋւo݂͂̂ۂ
#degits=3 : ̊ۂ
#cr1=F : ϒl̍̊_
#cr2=F : 臏㗦̊_
#cr3=F : ʗʂ̊_
#cr4=F : _̕W΍̊_
#ra= 1.0:֏
#rb=-1.0:։
#pr1=F : dx̊m
#pr2=F : Dz̊m
#pr3=F : 臏㗦̊m
#pr4=F : ̊m
##########################################################################
print.G2pair<-function(x,onlydiff=T,degits=3,cr1=F,cr2=F,cr3=F,cr4=F,ra= 1.0,rb= -1.0,pr1=F,pr2=F,pr3=F,pr4=F)
{
   EQU<-x$EQU; prior<-x$prior;
   if (EQU>0.5) {print("******************Uf******************")}
           else {print("******************ٕUf******************")}
   if (prior) {print("******************Ozw******************")}
             else {print("******************OzftHg******************")}
   mu1<-x$mu1; mu2<-x$mu2; sigma1<-x$sigma1; sigma2<-x$sigma2; 
   rho<-x$rho; xaste1<-x$xaste1; xaste2<-x$xaste2; log_lik<-x$log_lik
   prob<-x$prob
   G<-matrix(0,length(mu1),12)
   G0<-sqrt(sigma1^2 + sigma2^2)
   G[,1] <- mu1 - mu2;                         #ϒl
   G[,2] <- G[,1]/sigma1;                      #ʗ1
   G[,3] <- G[,1]/sigma2;                      #ʗ2
   G[,4] <- pnorm(mu1,mu2,sigma2);             #dx1
   G[,5] <- 1-pnorm(mu2,mu1,sigma1);           #dx2
   G[,6] <- pnorm((G[,1]/G0), 0.0, 1.0);       #Dz
   #ȉArho𗘗p
   G[,7] <- sqrt(sigma1^2 + sigma2^2 -2*rho*sigma1*sigma2);  #_sd
   G[,8] <- G[,1]/G[,7];                       #_̌ʗ
   G[,9] <- pnorm(G[,8], 0.0, 1.0);            #_̗Dz
   G[,10] <- 0.5+asin(rho)/pi                  #
   co<-10; lab<-c("ϒl̍","ʗ1","ʗ2","dx1Q","dx2Q","Dz","_sd","_̌ʗ","_̗Dz","")
   if(is.numeric(cr2)){
         co<- co+1; G[,co]<- pnorm((G[,1]-cr2)/G0, 0.0, 1.0);
         lab<-c(lab,paste("臏㗦(",cr2,")",sep=""))
         co<- co+1; G[,co]<- pnorm((G[,1]-cr2)/G[,7], 0.0, 1.0);
         lab<-c(lab,paste("_臏㗦(",cr2,")",sep=""))
   }
   if (onlydiff) {if (is.numeric(cr2)) {Grow<-c(1,7:10,12)} else {Grow<-c(1,7:10)}}
   else {if (is.numeric(cr2)) {Grow<-c(1:12)} else {Grow<-c(1:10)}};
   Gc<-cbind(
      apply(G[,Grow],2,mean),
      apply(G[,Grow],2,sd),
      t(apply(G[,Grow],2,quantile, probs=prob))
   )
   colnames(Gc)<-c("EAP","post.sd",prob)
   rownames(Gc)<-lab[Grow]

   U<-matrix(0,length(mu1),21)
   U[,1] <- ifelse(G[,1]>0.0,  1, 0);
   U[,2] <- ifelse(G[,1]<=0.0, 1, 0);
   U[,3] <- ifelse(xaste1-xaste2>0.0, 1, 0);
   U[,4] <- ifelse((rb<=rho)&(rho<=ra), 1, 0);
   co<-4;lab<-c("1-20傫m","1-20ȉ̊m","_̗Dz(ڔr)",paste("ւ",rb,"",ra,"̊Ԃɂm",sep=""))
   if(is.numeric(cr4)){co<- co+1;U[,co]<- ifelse(G[,7]< cr4,1, 0);
         lab<-c(lab,paste("_sd(",cr4,")菬m",sep=""))}
   if(is.numeric(cr2)){co<- co+1;U[,co]<- ifelse(xaste1-xaste2> cr2,1, 0);
         lab<-c(lab,paste("_臏㗦(",cr2,")(ڔr)",sep=""))}
   if(is.numeric(cr1)){co<- co+1;U[,co]<- ifelse(G[,1]> cr1,    1, 0);
         lab<-c(lab,paste("1-2(",cr1,")傫m",sep=""))}
   if(is.numeric(cr3)){co<- co+1;U[,co]<- ifelse(G[,8]> cr3, 1, 0);
         lab<-c(lab,paste("_̌ʗʂ(",cr3,")傫m",sep=""));}
   if(is.numeric(pr2)){co<- co+1;U[,co]<- ifelse(G[,9]> pr2,    1, 0);
         lab<-c(lab,paste("_̗Dz(",pr2,")傫m",sep=""))}
   if((is.numeric(cr2))&(is.numeric(pr3)))
                      {co<- co+1;U[,co]<- ifelse(G[,12]> pr3,    1, 0);
         lab<-c(lab,paste("_臏㗦(",cr2,")(",pr3,")傫m",sep=""))}
   if(is.numeric(pr4)){co<- co+1;U[,co]<- ifelse(G[,10]> pr4,    1, 0);
         lab<-c(lab,paste("(",pr4,")傫m",sep=""))}
   if(!onlydiff & is.numeric(cr3)){co<- co+1;U[,co]<- ifelse(G[,2]> cr3, 1, 0);
         lab<-c(lab,paste("ʗ1(",cr3,")傫m",sep=""));
                       co<- co+1;U[,co]<- ifelse(G[,3]> cr3,    1, 0);
         lab<-c(lab,paste("ʗ2(",cr3,")傫m",sep=""))}
   if(!onlydiff & is.numeric(pr1)){co<- co+1;U[,co]<- ifelse(G[,4]> pr1, 1, 0);
         lab<-c(lab,paste("1Q̔dx(",pr1,")傫m",sep=""));
                       co<- co+1;U[,co]<- ifelse(G[,5]> pr1,    1, 0);
         lab<-c(lab,paste("2Q̔dx(",pr1,")傫m",sep=""))}
   if(!onlydiff & is.numeric(pr2)){co<- co+1;U[,co]<- ifelse(G[,6]> pr2, 1, 0);
         lab<-c(lab,paste("Dz(",pr2,")傫m",sep=""))}
   if(!onlydiff & (is.numeric(cr2))&(is.numeric(pr3)))
                      {co<- co+1;U[,co]<- ifelse(G[,11]> pr3,    1, 0);
         lab<-c(lab,paste("臏㗦(",cr2,")(",pr3,")傫m",sep=""))}
   if(co>0.9){
      Uc<-matrix(colMeans(as.matrix(U[,1:co])),co,1);
      rownames(Uc)<-lab
      }else{Uc<-0.0}
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(round(Gc,degits))
   print(round(Uc,degits))
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(G=G,Gc=Gc,Uc=Uc,waic=waic)
   return(invisible(out))
}  
